import axios from 'axios'
import {Notification, MessageBox, Message, Loading} from 'element-ui'
import store from '@/store'
import {getToken} from '@/utils/auth'
import errorCode from '@/utils/errorCode'
import {tansParams, blobValidate} from "@/utils/ruoyi";
import cache from '@/plugins/cache'
import {saveAs} from 'file-saver'
import modal from '@/plugins/modal'

import i18n from '@/utils/lang/index'

let downloadLoadingInstance;
// 是否显示重新登录
export let isRelogin = {show: false};

axios.defaults.headers['Content-Type'] = 'application/json;charset=utf-8'
// 创建axios实例
const service = axios.create({
  // axios中请求配置有baseURL选项，表示请求URL公共部分
  baseURL: process.env.VUE_APP_BASE_API,
  // 超时
  timeout: 100000
})

// request拦截器
service.interceptors.request.use(config => {
  // 是否需要设置 token
  const isToken = (config.headers || {}).isToken === false
  // 是否需要防止数据重复提交
  const isRepeatSubmit = (config.headers || {}).repeatSubmit === false
  if (getToken() && !isToken) {
    config.headers['Authorization'] = 'Bearer ' + getToken() // 让每个请求携带自定义token 请根据实际情况自行修改
  }

  let language = localStorage.getItem("local");
  if (!(language != null && language != "" && language != undefined)) {
    language = 'zh-CN';
  }
  switch (language) {
    case "chinese" :
      language = 'zh-CN'
      break;
    case "russia" :
      language = 'ru-RU'
      break;
    case "english" :
      language = 'en-US'
      break;
    case "spanish" :
      language = 'es-ES'
      break;
    default:
      language = 'zh-CN';
  }
  config.headers['language'] = language;
  //设置时区
  let zone = Intl.DateTimeFormat().resolvedOptions().timeZone;
  config.headers['zone'] = zone;


  // get请求映射params参数
  if (config.method === 'get' && config.params) {
    let url = config.url + '?' + tansParams(config.params);
    url = url.slice(0, -1);
    config.params = {};
    config.url = url;
  }
  if (!isRepeatSubmit && (config.method === 'post' || config.method === 'put')) {
    const requestObj = {
      url: config.url,
      data: typeof config.data === 'object' ? JSON.stringify(config.data) : config.data,
      time: new Date().getTime()
    }
    const requestSize = Object.keys(JSON.stringify(requestObj)).length; // 请求数据大小
    const limitSize = 5 * 1024 * 1024; // 限制存放数据5M
    if (requestSize >= limitSize) {
      console.warn(`[${config.url}]: ` + '请求数据大小超出允许的5M限制，无法进行防重复提交验证。')
      return config;
    }
    const sessionObj = cache.session.getJSON('sessionObj')
    if (sessionObj === undefined || sessionObj === null || sessionObj === '') {
      cache.session.setJSON('sessionObj', requestObj)
    } else {
      const s_url = sessionObj.url;                  // 请求地址
      const s_data = sessionObj.data;                // 请求数据
      const s_time = sessionObj.time;                // 请求时间
      const interval = 1000;                         // 间隔时间(ms)，小于此时间视为重复提交
      if (s_data === requestObj.data && requestObj.time - s_time < interval && s_url === requestObj.url) {
        const message = i18n.t('common.processingData');
        console.warn(`[${s_url}]: ` + message)
        return Promise.reject(new Error(message))
      } else {
        cache.session.setJSON('sessionObj', requestObj)
      }
    }
  }
  return config
}, error => {
  console.log(error)
  Promise.reject(error)
})

// 响应拦截器
service.interceptors.response.use(res => {
    // 未设置状态码则默认成功状态
    const code = res.data.code || 200;
    // 获取错误信息
    const msg = errorCode[code] || res.data.msg || errorCode['default']
    // 二进制数据则直接返回
    if (!res.config.skipDownload && (res.request.responseType === 'blob' || res.request.responseType === 'arraybuffer')) {
      if (res.headers['content-type'] && res.headers['content-type'].indexOf('application/octet-stream') > -1) {
        return downloadFile(res, res.config.preview)
      }
      return res.data
    }
    if (code === 401) {
      if (!isRelogin.show) {
        isRelogin.show = true;
        MessageBox.confirm(i18n.t('common.sessionExpired'), i18n.t('common.systemTip'), { confirmButtonText: i18n.t('common.reLogin'), cancelButtonText: i18n.t('common.cancel'), type: 'warning' }).then(() => {
          isRelogin.show = false;
          store.dispatch('LogOut').then(() => {
            location.href = '/index';
          })
        }).catch(() => {
          isRelogin.show = false;
        });
      }
      modal.closeLoading()
      return Promise.reject(i18n.t('common.invalidSession'))
    } else if (code === 500) {
      Message({message: msg, type: 'error'})
      modal.closeLoading()
      return Promise.reject(new Error(msg))
    } else if (code === 601) {
      Message({message: msg, type: 'warning'})
      modal.closeLoading()
      return Promise.reject('error')
    } else if (code !== 200) {
      Notification.error({title: msg})
      modal.closeLoading()
      return Promise.reject('error')
    } else {
      return res.data
    }
  },
  error => {
    console.log('err' + error)
    let {message} = error;
    if (message == "Network Error") {
      message = i18n.t('common.backendConnectionError');
    } else if (message.includes("timeout")) {
      message = i18n.t('common.apiTimeout');
    } else if (message.includes("Request failed with status code")) {
      // message = "系统接口" + message.substr(message.length - 3) + "异常";
      message = i18n.t('common.apiErrorTemplate', [message.substr(message.length - 3)]);
    }
    Message({message: message, type: 'error', duration: 5 * 1000})
    return Promise.reject(error)
  }
)

//导入下载
export function downloadFile(res, preview) {
  if (!res || res.code == 500) {
    Message.error(res.message  || i18n.t('common.downloadFailed'))
    return false
  }

  // 1. 预览则返回本地url
  const blob = new Blob([res.data], {type: 'application/pdf;charset=utf-8'})
  if (preview) {
    return window.URL.createObjectURL(blob)
  }

  // 2. 提取文件名
  const contentDisposition = res.headers['content-disposition'] // 从response的headers中获取filename, 后端response.setHeader("Content-disposition", "attachment; filename=xxxx.docx") 设置的文件名;
  const patt = new RegExp('filename=([^;]+\\.[^\\.;_]+);*')
  const result = patt.exec(contentDisposition)
  const filename = decodeURI(result[1])



  // 3. 下载则直接下载
  const downloadElement = document.createElement('a')
  const href = window.URL.createObjectURL(blob)
  downloadElement.style.display = 'none'
  downloadElement.href = href
  downloadElement.download = filename // 下载后文件名
  document.body.appendChild(downloadElement)
  downloadElement.click() // 点击下载
  document.body.removeChild(downloadElement) // 下载完成移除元素
  window.URL.revokeObjectURL(href) // 释放掉blob对象
}

// 通用下载方法
export function download(url, params, filename, config) {
  downloadLoadingInstance = Loading.service({text: "Loading", spinner: "el-icon-loading", background: "rgba(0, 0, 0, 0.7)",})
  return service.post(url, params, {
    transformRequest: [(params) => {
      return tansParams(params)
    }],
    headers: {'Content-Type': 'application/x-www-form-urlencoded'},
    responseType: 'blob',
    ...config
  }).then(async (data) => {
    let file = await data
    if (!data) {
      downloadLoadingInstance.close();
      return
    }
    const isBlob = blobValidate(data);
    if (isBlob) {
      const blob = new Blob([data])
      saveAs(blob, filename)
    } else {
      const resText = await data.text();
      const rspObj = JSON.parse(resText);
      const errMsg = errorCode[rspObj.code] || rspObj.msg || errorCode['default']
      Message.error(errMsg);
    }
    downloadLoadingInstance.close();
  }).catch((r) => {
    console.error(r)
    Message.error(i18n.t('common.downloadError'))
    downloadLoadingInstance.close();
  })
}

export default service
